<?
define ("CATSOCK_PORT", 4900);
define ("CATSOCK_ADDR", "127.0.0.1");
define ("CATSOCK_RXD_LEN", 4096);
define ("CATSOCK_LOG_FILE", "/tmp/catsock.log");

define ("PS1", "\x01");										// Protocol separator level 1
define ("PS2", "\x02");										// Protocol separator level 2
define ("PS4", "\x04");										// Protocol end of transmission


function catsock_connect($type,$string_data)
{
return catsock_out_session($type,$_SESSION['client'],$_SESSION['passwd'],$_SESSION['usrnum'],$string_data);
}

function catsock_out_session($type,$client,$passwd,$usrnum,$string_data)
{														// CODE CLIENT USER PWD DATA[3];....
$socket = socket_create(AF_INET,SOCK_STREAM,SOL_TCP);
if($socket==false) return 'ERR'.PS1 .socket_strerror(socket_last_error());
$ret = socket_connect($socket,CATSOCK_ADDR,CATSOCK_PORT);
if($ret==false) {										// SECOND TRY
	sleep(2);
	$ret = socket_connect($socket,CATSOCK_ADDR,CATSOCK_PORT);
	}
if($ret==false) {
	socket_close($socket);
	return 'ERR'.PS1.socket_strerror(socket_last_error());
	}
$request = $type.PS1.real_ip().PS2.$client.PS2.$passwd.PS2.$usrnum.PS1.$string_data.PS1.PS4;
$ret = socket_write($socket,$request,strlen($request));
if($ret==false) {socket_close($socket); return 'ERR'.PS1.socket_strerror(socket_last_error());}
for($i=0,$ret_data="";$i<20; ) {						// 20 read waiting PS4
	$data = socket_read($socket,CATSOCK_RXD_LEN);
	if($data==false) {
		$ret_data = 'ERR'.PS1.socket_strerror(socket_last_error());
		break;
		}
	$ret_data .= $data;
	if(substr($data,-1)==PS4) {$ret_data = substr($ret_data,0,-1); break;}
	if(strlen($data)==0) {usleep(10000); $i++;}
	}
socket_close($socket);
return $ret_data;
}

function real_ip()											// ip address from user PC
{
if(isset($_SERVER)) {
	if(isset($_SERVER["HTTP_X_FORWARDED_FOR"])) $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
	elseif(isset($_SERVER["HTTP_CLIENT_IP"])) $realip = $_SERVER["HTTP_CLIENT_IP"];
	else $realip = $_SERVER["REMOTE_ADDR"];
	}
else {
	if(getenv('HTTP_X_FORWARDED_FOR')) $realip = getenv('HTTP_X_FORWARDED_FOR');
	elseif(getenv('HTTP_CLIENT_IP')) $realip = getenv('HTTP_CLIENT_IP');
	else $realip = getenv('REMOTE_ADDR');
	}
return $realip;
}

?>
