function XHRConnection() {
var conn = false;
var datas = new String();
var areaId = new String();
var xmlObj;
var xmlLoad;

try {conn = new XMLHttpRequest();}
catch (error) {
	try {conn = new ActiveXObject("Microsoft.XMLHTTP");}
	catch (error) {
		try {conn = new ActiveXObject("Msxml2.XMLHTTP");}
		catch (error) {
			conn = false;
			}
		}
	}

this.resetData = function() {datas = new String(); datas = '';};

this.appendData = function(pfield, pvalue) {
	datas += (datas.length == 0) ? pfield + "=" + escape(pvalue) : "&" + pfield + "=" + escape(pvalue);
	};

this.setRefreshArea = function(id) {areaId = id;};

this.createXMLObject = function() {
	try {
	 	xmlDoc = document.implementation.createDocument("","",null);
		xmlLoad = 'onload';
		}
	catch (error) {
		try {
			xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
			xmlLoad = 'onreadystatechange ';
			}
		catch (error) {
			return false;
			}
		}
	return xmlDoc;
	}

this.setXMLObject = function(obj) {
	if(obj == undefined) {
		return false;
		}
	try {xmlObj = obj;}
	catch (error) {
		}
	}

this.loadXML = function(xml,callBack) {
	if(!conn) return false;
	if(xmlObj && xml) {
		if(typeof callBack == "function") {
			if(xmlLoad == 'onload') {
				xmlObj.onload = function() {callBack(xmlObj);}
				}
			else {
				xmlObj.onreadystatechange = function() {
					if(xmlObj.readyState == 4) callBack(xmlObj)
					}
				}
			}
		xmlObj.load(xml);
		return;
		}		
	}

this.sendAndLoad = function(Url, httpMode, callBack) {
	httpMode = httpMode.toUpperCase();
	conn.onreadystatechange = function() {
		if(conn.readyState == 4 && (conn.status == 200 || conn.status == 0)) {
			if(typeof callBack == "function") {
				callBack(conn);
				return;
				}
			else if(areaId.length > 0){
				try {document.getElementById(areaId).innerHTML = conn.responseText;}
				catch(error) {
					}
				return;
				}
			}
		};
	switch(httpMode) {
		case "GET":
			try {
				Url = (datas.length > 0) ? Url + "?" + datas : Url;
				conn.open("GET", Url);
				conn.send(null);
				}
			catch(error) {
				return false;
				}
			break;
		case "POST":
			try {
				conn.open("POST", Url); 
				conn.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				conn.send(datas);
				}
			catch(error) {
				return false;
				}
			break;
		default :
			return false;
			break;
		}
	return true;
	};
	
this.sendAndLoadSynchron = function(Url, httpMode) {
	httpMode = httpMode.toUpperCase();

	switch(httpMode) {
	case "GET":
		try {
			Url = (datas.length > 0) ? Url + "?" + datas : Url;
			conn.open("GET", Url, false);
			conn.send(null);
			}
		catch(error) {
			return false;
			}
		break;
	case "POST":
		try {
			conn.open("POST", Url, false); 
			conn.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			conn.send(datas);
			}
		catch(error) {
			return false;
			}
		break;
	default :
		return false;
		break;
	}

	if(conn.readyState == 4 && conn.status == 200) {
		if (areaId.length > 0){
			try {
				document.getElementById(areaId).innerHTML = conn.responseText;
				}
			catch(error) {
				}
			return;
			}
		else {
			return conn;
			}
		}
	};
return this;
}

