<?
define ("BOX_TIMOUT", 5000);
define ("ADM_SOCKET_NAME", "/var/run/socket_adm");
define ("ADM_RXD_LEN", 25);
define ("TS7LOG", "/root/TS7600LIB/log");
define ("PRODUCT_COMPANY", "COSMO / LILAS GROUP");
define ("SUPPORT_COMPANY", "support@cosmotime.be");
define ("CONTACT_COMPANY", "+32 2 669 02 02");
define ("ADDR_FR_COMPANY", "Chausse de Louvain,37 - B3080 TERVUREN");
define ("ADDR_NL_COMPANY", "Leuvensesteenweg,37 - B3080 TERVUREN");
define ("ADDR_EN_COMPANY", "Roadway of Leuven,37 - B3080 TERVUREN");

$fct = array("N.U","TIM","N.U","ACC","CON","N.U","JOB");
$lgg = array("NO","EN","FR","NL");
$rel = array("Off","Rel1","Rel2");

function admin_cmd($cmd)
{
$ret = false;
if(($socket = socket_create(AF_UNIX,SOCK_STREAM,0))==false) ;
else if(socket_connect($socket,ADM_SOCKET_NAME)==false) ;
else if(socket_write($socket,$cmd,strlen($cmd))==false) ;
else if(($data = socket_read($socket,ADM_RXD_LEN,PHP_NORMAL_READ))==false) ;
else $ret = true;
if($ret==false) $data = 'ERR:'.socket_strerror(socket_last_error());
if($socket!=false) socket_close($socket);
return $data;
}

function session_control($ope='user')
{
if(!isset($_SESSION['clientname'])) {
	header("Location:login.php?action=timout");				// Redirection en cas d'echec
	exit;
	}
if($ope=='admin' && $_SESSION['usrnum']!='admin' && $_SESSION['usrnum']!='cosmo') {
	header("Location:login.php?action=level");				// Redirection en cas d'echec
	exit;
	}
if($_SESSION['help']!='off' && $_SERVER['PHP_SELF']!='/help.php') {
	header("Location:help.php?action=online&help=".substr($_SERVER['PHP_SELF'],1));
	exit;
	}
}

function alphanum($input) {return preg_replace('/[^A-Za-z0-9]/','',$input);}
function sform($input) {return preg_quote(strip_tags($input));}
function squote($input) {return str_replace("'"," ",str_replace('"'," ",strip_tags($input)));}

function msg($mess_fr,$mess_nl='?nl?',$mess_en='?en?')
{															// return mess following user lang
if($_SESSION['lang']=='fr') return $mess_fr;
if($_SESSION['lang']=='nl') return $mess_nl;
return $mess_en;
}

function box_ok($mess)
{
echo("<div id='box_mess' class='box_mess'>");
echo("<img class='box_img' src='images/ok.gif' />");
echo("<img class='box_close' src='images/close.png' onclick='box_hidden();' />");
echo("<span>".$mess."</span>");
echo("</div>");
}

function box_att($mess)
{
echo("<div id='box_mess' class='box_mess'>");
echo("<img class='box_img' src='images/att.png' />");
echo("<img class='box_close' src='images/close.png' onclick='box_hidden();' />");
echo("<span>".$mess."</span>");
echo("</div>");
}

function box_err($mess)
{
echo("<div id='box_mess' class='box_mess'>");
echo("<img class='box_img' src='images/ko.gif' />");
echo("<img class='box_close' src='images/close.png' onclick='box_hidden();' />");
echo("<span>".$mess."</span>");
echo("</div>");
}

function box_wait($mess)
{
echo("<div id='box_wait' class='box_mess'>");
echo("<img class='box_img' src='images/att.png' />");
echo("<span>".$mess."</span>");
echo("</div>");
}

function amp_char_decode($str)
{
$amp_code = array("&rsquo;","&lsquo;","&quot;","&nbsp;","&amp;","&lt;","&gt;");
$char_out = array("'","'","\""," ","&","<",">");
return str_replace($amp_code,$char_out,$str);
}

function page_header($mana=true)
{
if($mana==false) $_SESSION['lang'] = "en";
echo("<div class='header'>");
echo("<span class='".($mana==false? 'cat3t':'cat3')."'>CAT-3</span>");
echo("<span class='web'>".($mana==false? 'Stand Alone Terminal':'Manager')."</span>");
echo("<span class='desc'>");
echo(msg("Enregistrement du temps et Contrle d'accs","Tijdsregistratie en Toegangscontrole","Time recording and Access control"));
echo("</span>");
if($mana==true) {
	echo("<span class='lang'>");
	if(empty($_SESSION['usrnum'])) {
		if($_SESSION['lang']!='fr') echo("<a href='login.php?lang=fr'>"); echo("FR"); if($_SESSION['lang']!='fr') echo("</a>");
		echo("&nbsp&nbsp");
		if($_SESSION['lang']!='nl') echo("<a href='login.php?lang=nl'>"); echo("NL"); if($_SESSION['lang']!='nl') echo("</a>");
		echo("&nbsp&nbsp");
		if($_SESSION['lang']!='en') echo("<a href='login.php?lang=en'>"); echo("EN"); if($_SESSION['lang']!='en') echo("</a>");
		}
	else echo("<a href='perso.php'>".$_SESSION['usrfirst']."&nbsp;".$_SESSION['usrname']."</a>");
	echo("<img style='padding-left:25px' src='images/logo_cosmo.png' alt='cosmo' />");
	echo("</span>");
	}
echo("</div>");
echo("<div class='pick_box' id='pick_box'></div>");				// Calendar pick box
}

function page_footer($date=false)
{
echo("<div>");
if($date==true) {
	echo("<span class='lang'><a href='");
	echo(($_SESSION['usrnum']=='admin' || $_SESSION['usrnum']=='cosmo')? "setrtc.php":"#");
	echo("'><span id='box_hour'>".date('H:i')."&nbsp;&nbsp;</span>");
	echo(date('d ').mon_name(date('m')).date(' Y')."</a></span>");
	}
echo("<span class='desc'>Copyright ".PRODUCT_COMPANY." &copy; 2013-".date('Y '));
echo(msg("tous droits rservs","alle rechten voorbehouden","all rights reserved")."</span>");
if(isset($_SESSION['client']))
	echo("<span class='desc'>Lic:".$_SESSION['client']."&nbsp;&nbsp;".$_SESSION['clientname']."</span>");
echo("</div>");
}
	
function menu_vertical($page_menu,$idx,$title)	// ouvre un li de niveau 1
{
$mypage = substr($_SERVER['PHP_SELF'],1); if(isset($_GET['action'])) $mypage .= "?action=".$_GET['action'];
$select = $page_menu[$mypage]['idx']==$idx? " id='sel'" : "";
echo("<li style='display:inline-block'".$select.">".$title);
echo("<ul>");									// ouvre un ul crit des li de niveau 2
foreach($page_menu as $key => $val) if($val['idx']==$idx) {
	if($key=='holiday.php' && !($_SESSION['acc_activ_days']>0 || $_SESSION['rng_activ_days']>0)) continue;
	if($key=='module.php') continue;
	if($key=='present.php' && !$_SESSION['usrpresent']) continue;
	echo("<li><a href='".$key."'>".$val[$_SESSION['lang']]."</a></li>");
	}
echo("</ul></li>");								// ferme le ul et le li de niveau 1
}

function menu_title($page_menu)
{												// affiche titre au bon endroit suivant page slectionne
$mypage = substr($_SERVER['PHP_SELF'],1); if(isset($_GET['action'])) $mypage .= "?action=".$_GET['action'];
echo("<div class='title_div'><div>");
if(isset($page_menu[$mypage])) {
	echo("<span id='name' style='margin-left:".($page_menu[$mypage]['idx']*151-140)."px'>");
	echo($page_menu[$mypage][$_SESSION['lang']]."</span>");
	}
echo("</div></div>");
}

function display_menu($title)					// affiche menu suivant tableau ci-dessous
{
echo("<div class='menu_div'>");
if($_SERVER['PHP_SELF']!='/help.php') {
	echo("<input type='button' class='help_button' value='".msg("Aide","Help","Help")."'");
	echo(" onclick=\"document.location='help.php?action=online&help=".substr($_SERVER['PHP_SELF'],1));
	echo("&title=".base64_encode($title)."'\" />");
	}
echo("<ul id='menu'>");
if($_SESSION['usrnum']=='admin' || $_SESSION['usrnum']=='cosmo') {
	$page_menu = array (
	"perso.php"					=>array("idx"=>1, "fr"=>"Personnel",	"nl"=>"Personeel",		"en"=>"Personal",		"ge"=>"Personal"),
	"password.php"				=>array("idx"=>1, "fr"=>"Mot de passe",	"nl"=>"Wachtwoord",		"en"=>"Password",		"ge"=>"Password"),
	"present.php"				=>array("idx"=>1, "fr"=>"Qui est l",	"nl"=>"Wie is er",		"en"=>"Who is there",	"ge"=>"Who is there"),
	
	"personal.php"				=>array("idx"=>2, "fr"=>"Personnel",	"nl"=>"Personeel",		"en"=>"Personal",		"ge"=>"Personal"),
	"history.php"				=>array("idx"=>2, "fr"=>"Pointages",	"nl"=>"Boekingen",		"en"=>"Clockings",		"ge"=>"Clockings"),
	"clocking.php"				=>array("idx"=>2, "fr"=>"Corrections",	"nl"=>"Correcties",		"en"=>"Corrections",	"ge"=>"Clockings"),

	"holiday.php"				=>array("idx"=>3, "fr"=>"Jours fris",	"nl"=>"Feestdagen",		"en"=>"Holidays",		"ge"=>"Holidays"),
	"relring.php"				=>array("idx"=>3, "fr"=>"Sonneries",	"nl"=>"Bellsignalen",	"en"=>"Ringings",		"ge"=>"Ringings"),
	"export.php"				=>array("idx"=>3, "fr"=>"Exportations",	"nl"=>"Exports",		"en"=>"Exports",		"ge"=>"Exports"),
	"param.php"					=>array("idx"=>3, "fr"=>"Paramtres",	"nl"=>"Parameters",		"en"=>"Parameters",		"ge"=>"Parameters"),
	"setrtc.php"				=>array("idx"=>3, "fr"=>"Date/heure",	"nl"=>"Datum/uur",		"en"=>"Date/hour",		"ge"=>"Date/hour"),
	"backup.php"				=>array("idx"=>3, "fr"=>"Backup/Update","nl"=>"Backup/Update",	"en"=>"Backup/Update",	"ge"=>"Backup/Update"),
	"module.php"				=>array("idx"=>3, "fr"=>"Modules",		"nl"=>"Modules",		"en"=>"Modules",		"ge"=>"Modules"),
	
	"acccode.php"				=>array("idx"=>4, "fr"=>"Codes temps",	"nl"=>"Tijdscodes",		"en"=>"Time codes",		"ge"=>"Time codes"),
	"acclvl.php"				=>array("idx"=>4, "fr"=>"Profils",		"nl"=>"Profielen",		"en"=>"Profiles",		"ge"=>"Profiles"),
	"acczone.php"				=>array("idx"=>4, "fr"=>"Zones",		"nl"=>"Zones",			"en"=>"Zones",			"ge"=>"Zones"),
	"accessing.php"				=>array("idx"=>4, "fr"=>"Liste Accs",	"nl"=>"Toegangslijst",	"en"=>"Access list",	"ge"=>"Access list"),

	"help.php?action=about"		=>array("idx"=>5, "fr"=>"A propos",		"nl"=>"About",			"en"=>"About",			"ge"=>"About"),
	"help.php?action=online"	=>array("idx"=>5, "fr"=>"Aide/Update",	"nl"=>"Help/Update",	"en"=>"Help/Update",	"ge"=>"Help/Update"),
	"t_status.php"				=>array("idx"=>5, "fr"=>"Technicien",	"nl"=>"Technicus",		"en"=>"Technician",		"ge"=>"Technician"),
	"login.php?action=logoff"	=>array("idx"=>5, "fr"=>"Dconnexion",	"nl"=>"Disconnect",		"en"=>"Disconnect",		"ge"=>"Disconnect")
	);
	menu_vertical($page_menu,1,msg("Votre compte","Uw rekening","Your account"));
	menu_vertical($page_menu,2,msg("Gestion Temps","Tijdsregistratie","Time management"));
	menu_vertical($page_menu,3,msg("Divers","Diversen","Others"));
	menu_vertical($page_menu,4,msg("Contrle Accs","Toegangscontrol","Access control"));
	menu_vertical($page_menu,5,"Exit");
	}
else {	
	$page_menu = array (
	"histo.php"					=>array("idx"=>1, "fr"=>"Pointages",	"nl"=>"Boekingen",		"en"=>"Clockings",		"ge"=>"Clockings"),
	"perso.php"					=>array("idx"=>1, "fr"=>"Personnel",	"nl"=>"Personeel",		"en"=>"Personal",		"ge"=>"Personal"),
	"password.php"				=>array("idx"=>1, "fr"=>"Mot de passe",	"nl"=>"Wachtwoord",		"en"=>"Password",		"ge"=>"Password"),
	"present.php"				=>array("idx"=>1, "fr"=>"Qui est l",	"nl"=>"Wie is er",		"en"=>"Who is there",	"ge"=>"Who is there"),
	
	"help.php?action=about"		=>array("idx"=>2, "fr"=>"A propos",		"nl"=>"About",			"en"=>"About",			"ge"=>"About"),
	"help.php?action=online"	=>array("idx"=>2, "fr"=>"Aide",			"nl"=>"Help",			"en"=>"Help",			"ge"=>"Help"),
	"login.php?action=logoff"	=>array("idx"=>2, "fr"=>"Dconnexion",	"nl"=>"Disconnect",		"en"=>"Disconnect",		"ge"=>"Disconnect")
	);
	menu_vertical($page_menu,1,msg("Votre compte","Uw rekening","Your account"));
	menu_vertical($page_menu,2,"Exit");	
	}
echo("</ul></div>");
menu_title($page_menu);
}

function t_display_menu()							// affiche menu suivant tableau ci-dessus
{
$page_menu = array (
	"t_status.php"						=>array("idx"=>1, "en"=>"Status"),
	"t_view_file.php?action=/tmp/proc"	=>array("idx"=>1, "en"=>"Processes"),
	"t_backclock.php"					=>array("idx"=>1, "en"=>"Retrieve clockings"),
	"t_password.php"					=>array("idx"=>1, "en"=>"Change password"),
	
	"t_comm.php"						=>array("idx"=>2, "en"=>"Communication"),
	"t_param.php"						=>array("idx"=>2, "en"=>"Terminal Settings"),
	"t_reader.php"						=>array("idx"=>2, "en"=>"Badge Readers"),
	"t_access.php"						=>array("idx"=>2, "en"=>"CACT Access"),
	
	"t_reboot.php"						=>array("idx"=>5, "en"=>"Reboot"),
	"t_reload.php"						=>array("idx"=>5, "en"=>"DB Update"),
	"t_login.php?action=logoff"			=>array("idx"=>5, "en"=>"Disconnect")
	);
	
if(read_config("../cfg/term_cfg","MYSELF_IP")=='Myself') {
	$sub = array(); $sub["idx"] = 2; $sub["en"] = "Master Settings";
	$page_menu["t_hcomm.php"] = $sub;
	}
$files = array_slice(scandir("../dat"),2);
foreach($files as $file) if(strstr($file,".xml")) {
	$sub = array(); $sub["idx"] = 3; $sub["en"] = $file;
	$page_menu["t_view_file.php?action=../dat/".$file] = $sub;
	}
$files = array_slice(scandir("../log"),2);
foreach($files as $file) {
	$sub = array(); $sub["idx"] = 4; $sub["en"] = $file;
	$page_menu["t_view_file.php?action=../log/".$file] = $sub;
	}
$files = array_slice(scandir(TS7LOG),2);
foreach($files as $file) {
	$sub = array(); $sub["idx"] = 4; $sub["en"] = $file;
	$page_menu["t_view_file.php?action=".TS7LOG."/".$file] = $sub;
	}
	
echo("<div class='menu_div'><ul id='menu'>");
menu_vertical($page_menu,1,"Home");
menu_vertical($page_menu,2,"Configuration");
menu_vertical($page_menu,3,"DB Images");
menu_vertical($page_menu,4,"Logging");
menu_vertical($page_menu,5,"Save/Exit");
echo("</ul></div>");
menu_title($page_menu);
}

function sel_option($value,$bcolor,$selected,$mess)
{
static $even;

$even = $even? false:true;
$ret = "<option value='".$value."'";
if($bcolor) $ret .= " style='background-color:".$bcolor."'";
else if($even) $ret .= " class='even'";
if($selected==$value) $ret .= " selected='selected'";
$ret .= ">".$mess."</option>";
return $ret;
}

function read_config($file,$entry,$separ='=',$default='',$count=1)	// $count = premire, deuxime ... instance
{
if(file_exists($file)===false) return $default;
$found = false;
if(($fp = fopen($file,"r"))!==false) {
	while(($buffer = fgets($fp,500))!=false) {
		if(($en = strpos($buffer,$entry))===false) continue;
		$buffer = substr($buffer,$en);
		if(($en = strpos($buffer,$separ))===false) continue;
		$buffer = substr($buffer,$en+1);
		$buffer = trim($buffer,"\~ \t\r\n");
		if(($en = strpos($buffer," "))!==false)
			$buffer = substr($buffer,0,$en);
		if(--$count>0) continue;
		$found = true;
		break;
		}
	fclose($fp);
	}
return $found==true? str_replace('~',' ',$buffer):$default;
}

function send_config($file,$entry,$data,$separ='=',$count=1)	// $count = premire, deuxime ... instance
{
$found = false;
if(file_exists($file)===false) $lines = array();			// load file in array
else if(($lines = file($file))===false) $lines = array();
else for($i=0;$i<count($lines);$i++) {						// search entry
	if(($en = strpos($lines[$i],$entry))===false) continue;					
	$output = substr($lines[$i],0,$en);						// prepare new line with pre entry
	$buf = substr($lines[$i],$en+strlen($entry));			// buf commence aprs entry
	if(($en = strpos($buf,$separ))===false)	continue;		// search separ
	if(--$count>0) continue;
	$output .= $entry.$separ.str_replace(' ','~',$data);	// complete new line
	$buf = substr($buf,$en+2);								// buf commence  separ + 2
	if(($en = strpos($buf," "))!==false)					// voir si qqchose derrire data
		$output .= substr($buf,$en);
	else $output .= "\n";
	$found = true;
	$lines[$i] = $output;
	break;
	}
if($found==false) array_push($lines,$entry.$separ.$data."\n");
$fp = fopen($file,"w");
foreach($lines as $line) fwrite($fp,$line);
fclose($fp);
return 0;
}

function is_flag_on($str)
{
if(strcasecmp($str,"1")==0) return 1;
if(strcasecmp($str,"on")==0) return 1;
if(strcasecmp($str,"yes")==0) return 1;
if(strcasecmp($str,"enable")==0) return 1;
return 0;
}

function print_file($file)
{
if(($fp = fopen($file,"r"))===false) return;
while(($buf = fgets($fp,500))!==false) echo($buf."<br />");
fclose($fp);
}

function hm_to_hour($hm)							// $hm = [>+-]HH:MM
{													// return [-]HHMM
$first = substr($hm,0,1);
if($first=='>' || $first=='+' || $first=='-' || $first==' ') $hm = substr($hm,1);
$hour = substr($hm,0,2);
$min = substr($hm,3,2);
if($first=='>') $hour += 24;
if($first=='-') return $first.$hour.$min;
return $hour.$min;
}

function hour_to_hm($hour)							// $hour = HH...HMM
{
$len = strlen($hour);
return substr($hour,0,$len-2).':'.substr($hour,$len-2,2);
}

function dmY_to_date($date)							// $date = dd-mm-yyyy
{													// return YYYYMMDD
return substr($date,6,4).substr($date,3,2).substr($date,0,2);
}

function dmYhm_to_date($date)						// $date = dd-mm-yyyy hh:mm
{													// return YYYYMMDDhhmm
return substr($date,6,4).substr($date,3,2).substr($date,0,2).substr($date,11,2).substr($date,14,2);
}

function datehour_to($format,$date)					// $date = YYYYMMDDhhmm
{
if(substr($date,0,8)=="19700101" || substr($date,0,8)=="99999999") return "";
$ts = mktime(substr($date,8,2),substr($date,10,2),0,substr($date,4,2),substr($date,6,2),substr($date,0,4));
return date($format,$ts);
}

function date_to_dmY($date)							// $date = YYYYMMDD(hhmmss)
{													// return dd-mm-yyyy hh:mm:ss
$ret = '';
if(strlen($date)) {
	$ret = substr($date,6,2).'-'.substr($date,4,2).'-'.substr($date,0,4);
	if(strlen($date)>8) $ret .= ' '.substr($date,8,2);
	if(strlen($date)>10) $ret .= ':'.substr($date,10,2);
	if(strlen($date)>12) $ret .= ':'.substr($date,12,2);
	}
return $ret;
}

function date_inc($date,$y,$m,$d)					// $date = YYYYMMDD
{													// inc with y m d
$ts = mktime(12,0,0,substr($date,4,2)+$m,substr($date,6,2)+$d,substr($date,0,4)+$y);
return date("Ymd",$ts);
}

function mon_name($monnum)					// 1=Jan 2=Fv ...
{
$mois = array("Jan","Fv","Mar","Avr","Mai","Jun","Jui","Ao","Sep","Oct","Nov","Dc");
$maan = array("Jan","Feb","Maa","Apr","Mei","Jun","Jul","Aug","Sep","Okt","Nov","Dec");
$mont = array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
$monnum = ($monnum-1)%12;
if($_SESSION['lang']=='fr') return $mois[$monnum];
if($_SESSION['lang']=='nl') return $maan[$monnum];
return $mont[$monnum];
}

function day_name($daynum)					// 0=Di 1=Lu ...
{
$jrse = array("Di","Lu","Ma","Me","Je","Ve","Sa");
$wdag = array("Zo","Ma","Di","Wo","Do","Vr","Za");
$wday = array("Su","Mo","Tu","We","Th","Fr","Sa");
$daynum = $daynum%7;
if($_SESSION['lang']=='fr') return $jrse[$daynum];
if($_SESSION['lang']=='nl') return $wdag[$daynum];
return $wday[$daynum];
}

function week_day($date)							// $date = YYYYMMDD
{
$timestamp = mktime(0,0,0,substr($date,4,2),substr($date,6,2),substr($date,0,4));
return day_name(date("w",$timestamp));
}

function client_to_rescuepwd($client)
{
if($client>=1000 && $client<=1600) $rescpwd = $client;
else $rescpwd = $client%600 + 1000;
$rescpwd = (($rescpwd*$rescpwd*$rescpwd)/10)%1000000;
if($rescpwd<100000) $rescpwd += 100000;
return $rescpwd;
}

?>