// Calendar control
// <!-- <![CDATA[

var ds_i_date = new Date();
var ds_c_month = ds_i_date.getMonth() + 1;
var ds_c_year = ds_i_date.getFullYear();
var ds_element;
var ds_form = 0;
var ds_ce = 0;										// Container
var ds_ob = '';										// Output Buffering

var month_fr = new Array('Janvier','Fvrier','Mars','Avril','Mai','Juin','Juillet','Aout','Septembre','Octobre','Novembre','Dcembre');
var month_nl = new Array('Januari','Februari','Maart','April','Mei','Juni','Juli','Augustus','September','Oktober','November','December');
var month_en = new Array('January','February','March','April','May','June','July','August','September','October','November','December');
var day_fr = new Array('Lu','Ma','Me','Je','Ve','Sa','Di');
var day_nl = new Array('Ma','Di','Wo','Do','Vr','Za','Zo');
var day_en = new Array('Mo','Tu','We','Th','Fr','Sa','Su');

function ds_template_main_above(m,y)
{
text = "<table cellpadding='1' cellspacing='1' class='ds_tbl'>";
text += "<tr><td class='ds_button' onclick='ds_inc(0,-1);'>&#x25C1;</td>";
text += "<td colspan='4' class='ds_head'>"+y+"</td>";
text += "<td class='ds_button' onclick='ds_inc(0,1);'>&#x25B7;</td>";
text += "<td class='ds_button' onclick='ds_hi();'>&#x2716;</td></tr>";
text += "<tr><td class='ds_button' onclick='ds_inc(-1,0);'>&#x25C1;</td>";
text += "<td colspan='4' class='ds_head'>"+m+"</td>";
text += "<td class='ds_button' onclick='ds_inc(1,0);'>&#x25B7;</td>";
text += "<td class='ds_button' onclick='ds_select(";
text += ds_i_date.getDate()+ ","+ (ds_i_date.getMonth()+1)+ ","+ ds_i_date.getFullYear()+ ")'>";
text += "&#x25A3;</td></tr><tr>";
return text;
}

function ds_template_day_row(n,t)
{
var cell_class = n<5? "ds_subhead":"ds_head";

cell_class = "ds_subhead";
return '<td class="' + cell_class + '">' + t + '</td>';
}

function ds_template_new_week()
{
return '</tr><tr>';
}

function ds_template_blank_cell(num)
{
if(!num) return '';
return '<td colspan="'+num+'"></td>'
}

function ds_template_day(d, m, y, w)
{
var	cell_class = "ds_cell";

if(ds_element.value==ds_format_date(d,m,y)) cell_class = "ds_curr";
else if(d==ds_i_date.getDate() && m==ds_i_date.getMonth()+1 && y==ds_i_date.getFullYear())
	cell_class = "ds_today";
else if(w==5 || w==6 ) cell_class = "ds_we";
return '<td class="'+cell_class+'" onclick="ds_select('+d+','+m+','+y+')">'+d+'</td>';
}

function ds_template_main_below(wday)
{
var s = '';
if(wday>0) {s += '<td'; if(wday<6) s += ' colspan="' + (7-wday) + '"'; s += '></td>';}
return s + '</tr></table>';
}

function ds_draw_calendar(m, y)
{
var cal = ds_template_main_above(msg(month_fr[m-1],month_nl[m-1],month_en[m-1]),y);
var ds_dc_date = new Date();

for(i=0;i<7;i++) cal += ds_template_day_row(i,msg(day_fr[i],day_nl[i],day_en[i]));
ds_dc_date.setDate(1);
ds_dc_date.setMonth(m - 1);
ds_dc_date.setFullYear(y);
var first_day = ds_dc_date.getDay();
if(first_day) first_day--; else first_day = 6;
if(m==1 || m==3 || m==5 || m==7 || m==8 || m==10 || m==12) days = 31;
else if(m==4 || m==6 || m==9 || m==11) days = 30;
else days = (y%4)? 28:29;
var first_loop = 1;
cal += ds_template_new_week();
cal += ds_template_blank_cell(first_day);
var j = first_day;
for(i=0;i<days;i++) {
	if(j==0 && !first_loop) cal += ds_template_new_week();
	cal += ds_template_day(i + 1, m, y, j);	
	first_loop = 0;
	j++; j%=7;	
	}
cal += ds_template_main_below(j);
return cal;
}

function ds_sh(t, formsubmit)
{
var ds_sh_date;
var d, m, y;

ds_element = t.previousSibling;
ds_ce = document.getElementById('pick_box');
ds_form = formsubmit;
ds_sh_date = new Date();
if(ds_element.value) {
	ds_sh_date.setDate(ds_element.value.substr(0,2));
	ds_sh_date.setMonth(ds_element.value.substr(3,2)-1);
	ds_sh_date.setFullYear(ds_element.value.substr(6,4));
	}
ds_c_month = ds_sh_date.getMonth() + 1;
ds_c_year = ds_sh_date.getFullYear();
ds_ce.innerHTML = ds_draw_calendar(ds_c_month,ds_c_year);
ds_ce.style.left = ds_getleft(t) + 'px';
ds_ce.style.top = ds_gettop(t) + 'px';
ds_ce.style.display = 'block';
}

function ds_hi()
{
ds_ce.style.display = 'none';
}

function ds_inc(m, y)
{
ds_c_month = ds_c_month + m;
if(ds_c_month>12) {ds_c_month = 1; y = 1;}
else if(ds_c_month<1) {ds_c_month = 12; y = -1;}
ds_c_year = ds_c_year + y;
ds_ce.innerHTML = ds_draw_calendar(ds_c_month,ds_c_year);
}

function ds_format_date(d, m, y)
{
m2 = '00' + m;
m2 = m2.substr(m2.length - 2);
d2 = '00' + d;
d2 = d2.substr(d2.length - 2);
return d2 + '-' + m2 + '-' + y;
}

function ds_date_format(dmy)
{
return dmy.substr(6,4) + dmy.substr(3,2) + dmy.substr(0,2);
}

function ds_select(d, m, y)
{
ds_hi();
ds_element.value = ds_format_date(d,m,y);
ds_element.className = 'inputdate';
if(ds_form) ds_form.click();
}

function ds_getleft(el)
{
var tmp = el.offsetLeft;
while((el = el.offsetParent)) tmp += el.offsetLeft;
return tmp;
}

function ds_gettop(el)
{
var tmp = el.offsetTop;
while((el = el.offsetParent)) tmp += el.offsetTop;
return tmp;
}

// ]]> -->

