// CAT3 TOOL
// <!-- <![CDATA[
var lang = 'en';

function setLang(lg)
{
lang = lg;
if((ele=document.getElementById('showit'))) ele.scrollIntoView(true);
}

function msg(mess_fr,mess_nl,mess_en)
{
if(lang=='fr') return mess_fr;
if(lang=='nl') return mess_nl;
return mess_en;
}

function red_conf()
{
if((el=document.form1.confirm)) el.style.color = 'red';
}

function box_hidden()
{
if((ele=document.getElementById('box_mess'))) ele.style.visibility = "hidden";
else if(document.all && (ele=document.all['box_mess'])) ele.style.visibility = "hidden";
else if(document.layers && (ele=document.layers['box_mess'])) ele.visibility = "hidden";
if((ele=document.getElementById('box_hour'))) ele.style.visibility = "hidden";
else if(document.all && (ele=document.all['box_hour'])) ele.style.visibility = "hidden";
else if(document.layers && (ele=document.layers['box_hour'])) ele.visibility = "hidden";
}

function hidden_id(ele_id)
{
if((ele=document.getElementById(ele_id))) ele.style.visibility = "hidden";
else if(document.all && (ele=document.all[ele_id])) ele.style.visibility = "hidden";
else if(document.layers && (ele=document.layers[ele_id])) ele.visibility = "hidden";
}

function trim_left(s,c)
{
while(s.charAt(0)==c) s = s.substr(1);
return s;
}

function mv_char(s,o,d)		// o=string of char to be replaced by char d
{
var ret = '';
for(i=0;i<s.length;i++) {
	for(j=0;j<o.length;j++) if(s.charAt(i)==o.charAt(j)) break;
	ret += j<o.length?  d:s.charAt(i);
	}
return ret;
}

function cnt_char(s,c)
{
for(i=n=0;i<s.length;i++) if(s.charAt(i)==c) n++;
return n;
}

function is_min_alpha(s) 
{
for(i=0;i<s.length;i++) {
	if(s.charCodeAt(i)>=65 && s.charCodeAt(i)<=90) return true;
	if(s.charCodeAt(i)>=97 && s.charCodeAt(i)<=122) return true;
	}
return false;
}

function is_alphanum(s) 
{
for(i=0;i<s.length;i++) {
	if(s.charCodeAt(i)>=48 && s.charCodeAt(i)<=57) continue;
	if(s.charCodeAt(i)>=65 && s.charCodeAt(i)<=90) continue;
	if(s.charCodeAt(i)>=97 && s.charCodeAt(i)<=122) continue;
	return false;
	}
return true;
}

function is_date(s)			// control + set at format DD-MM-YYYY return '' if error
{
s = mv_char(s,'/.','-');
if(cnt_char(s,'-')!=2) return '';
tabDate = s.split('-');
if(tabDate[0].length<2) tabDate[0]= '0' + tabDate[0];
if(tabDate[1].length<2) tabDate[1]= '0' + tabDate[1];
if(tabDate[2].length<4) tabDate[2]= '20' + tabDate[2];
s = tabDate[0] + '-' + tabDate[1] + '-' + tabDate[2];
if(s.length!=10) return '';
for(i=0;i<10;i++) if(s.charAt(i)!='-' && !(s.charAt(i)>='0' && s.charAt(i)<='9')) return '';
return s;
}

function is_hour(s,fmt)		// control + set at format [>+-]HH:MM  fmt=0,'>','-' return '' if error
{
to = 0; sign = '';
if(s.charAt(0)=='>') {if(fmt!='>') return ''; else {s = s.substring(1); to = 24;}}
else if(s.charAt(0)=='+') {if(fmt!='-') return ''; else {s = s.substring(1); sign = '+';}}
else if(s.charAt(0)=='-') {if(fmt!='-') return ''; else {s = s.substring(1); sign = '-';}}
s = mv_char(s,'.,*/;',':');
c = cnt_char(s,':');
if(s=='' || c>1) return '';
for(i=0;i<s.length;i++) if(s.charAt(i)!=':' && !(s.charAt(i)>='0' && s.charAt(i)<='9')) return '';
tabhr = s.split(':');
h = parseInt(tabhr[0]) + to;
m = (c==0 || tabhr[1]=='')? 0:parseInt(tabhr[1]);
if(m>59 || (h*60+m)>2160) return '';
if(h<10) h = '0' + h;
if(m<10) m = '0' + m;
return sign + h + ':' + m;
}

function str_to_date(s)		// s = DD-MM-YYYY hh:mm:ss	return sec from 1-1-70
{							//     01234567890123456789
var d = new Date();
d.setFullYear(s.substr(6,4));
d.setMonth(s.substr(3,2)-1);
d.setDate(s.substr(0,2));
d.setHours(s.length>12? s.substr(11,2):0);
d.setMinutes(s.length>15? s.substr(14,2):0);
d.setSeconds(s.length>18? s.substr(17,2):0);
d.setMilliseconds(0);
return d.getTime()/1000;         
}

function date_to_str(date)		// date = Date()		return dd-mm-yyyy
{
d = date.getDate();			if(d<10) d = '0' + d;
m = date.getMonth() + 1;	if(m<10) m = '0' + m;
y = date.getFullYear();
return d + "-" + m + "-" + y;
}

function beg_week(date)			// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
day = d.getDay(); day = d.getDate() - (day? day-1:6);
d.setDate(day);
return date_to_str(d);
}

function beg_prev_w(date)		// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
d.setDate(d.getDate()-7);
return beg_week(date_to_str(d));
}

function end_week(date)			// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
day = d.getDay(); day = d.getDate() + (day? 7-day:0);
d.setDate(day);
return date_to_str(d);
}

function end_prev_w(date)		// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
d.setDate(d.getDate()-7);
return end_week(date_to_str(d));
}

function beg_month(date)		// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/01/'+date.substr(6,4));
//d.setDate(1);
return date_to_str(d);
}

function beg_prev_m(date)		// date = Date()		return dd-mm-yyyy
{
//var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
var d = new Date(date.substr(3,2)+'/15/'+date.substr(6,4));
d.setMonth(d.getMonth()-1); 
return beg_month(date_to_str(d));
}

function end_month(date)		// date = Date()		return dd-mm-yyyy
{
//var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
var d = new Date(date.substr(3,2)+'/15/'+date.substr(6,4));
d.setMonth(d.getMonth()+1);
d.setDate(0);
return date_to_str(d);
}

function end_prev_m(date)		// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
d.setDate(0);
return date_to_str(d);
}

function yesterday(date)		// date = Date()		return dd-mm-yyyy
{
var d = new Date(date.substr(3,2)+'/'+date.substr(0,2)+'/'+date.substr(6,4));
d.setDate(d.getDate()-1);
return date_to_str(d);
}

function num_ctrl(element,neg) 
{
var c = element.value;
var d = "";
var error = 0;
var i;

for(i=0; i<c.length; i++) {
	if(c.charAt(i)>='0' && c.charAt(i)<='9') d += c.charAt(i);
	else if(i==0 && neg==true && c.charAt(i)=='-') d += c.charAt(i);
	else error = 1;
	}
if(error==1) element.value = d;
}

function num_ctrl_end(element,min,max) 
{
if(parseInt(element.value)<parseInt(min)) element.value = min;
else if(parseInt(element.value)>parseInt(max)) element.value = max;
}

function num_separ_ctrl(element) 
{
var c = element.value;
var d = "";
var error = 0;
var i;

for(i=0;i<c.length;i++) {
	if(c.charAt(i)>='0' && c.charAt(i)<='9') d += c.charAt(i);
	else if(c.charAt(i)==',' || c.charAt(i)=='.') d += c.charAt(i);
	else error = 1;
	}
if(error==1) element.value = d;
}

function ipaddr_ctrl(element) 
{
var c = element.value;
var d = "";
var error = 0;
var i;

for(i=0; i<c.length; i++) {
	if(c.charAt(i)>='0' && c.charAt(i)<='9') d += c.charAt(i);
	else if(c.charCodeAt(i)==46) d += c.charAt(i);
	else error = 1;
	}
if(error==1) element.value = d;
}

// ]]> -->

